package macampcorp.macamp.ui;

import android.app.Activity;
import android.content.Context;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.SoundPool;
import android.os.Build;
import android.os.VibrationEffect;
import android.os.Vibrator;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;

import macampcorp.macamp.activities.R;

public class Sound {

    public static void play(Activity a, int res) {
        MediaPlayer mediaPlayer = MediaPlayer.create(a, res);
        mediaPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
        mediaPlayer.setLooping(false);
        mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
            @Override
            public void onCompletion(MediaPlayer mp) {
                mp.stop();
                mp.release();
            }
        });
        mediaPlayer.start();
    }


    public static void boom(Activity a)
    {
        play(a, R.raw.boom);
    }

    public static void ok(Activity a)
    {
        play(a, R.raw.ok);
    }

    public static void fail(Activity a)
    {
        play(a, R.raw.fail);
        vibrate(a,500);
        animateFail(a);
    }

    public static void animateFail(Activity a)
    {
        View v = a.getWindow().getDecorView().findViewById(android.R.id.content);
        final Animation animShake = AnimationUtils.loadAnimation(a, R.anim.shake);
        v.startAnimation(animShake);
    }

    public static void vibrate(Activity a, int ms)
    {
        Vibrator v = (Vibrator) a.getSystemService(Context.VIBRATOR_SERVICE);
        // Vibrate for 500 milliseconds
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            v.vibrate(VibrationEffect.createOneShot(500,VibrationEffect.DEFAULT_AMPLITUDE));
        }else{
            //deprecated in API 26
            v.vibrate(500);
        }
    }
}
